// skST7735x基本ライブラリの描画サンプル
//  Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <skST7735x.h>

// IC=ST7735R 1.8インチ 18ビットカラー 128x160ドット (緑タブシール)
// IC=ST7735S 1.8TFT SPI 128*160 V1.1  (緑タブシール)
skST7735x LCD=skST7735x(CHIP_ST7735X | DISPLAY_TYPE_1) ;

void setup()
{
     Serial.begin(9600) ;

     // ディスプレイモジュールの初期化を行う
     LCD.begin(BLACK_SCREEN) ;

     LCD.ColorSet(63,63,63) ;      // 白色
     LCD.Puts2x(40,0,"Arduino") ;
     LCD.Line(0,16,159,16) ;
     LCD.FillBox(20,25,139,105) ;
     LCD.ColorSet(63,0,0) ;        // 赤色
     LCD.FillCircle(80,65,32) ;
     LCD.ColorSet(63,40,0) ;       // 橙色
     LCD.Puts(25,115,"Hello, how are you") ;
}
void loop()
{
 
     delay(1000) ;
}

