/*******************************************************************************
*  skST7735x_10key - ST7735`bvTFT-LCDp֐Cu(10L[͕)       *
*                    ST7735R/S`bv(ΐF^u)̂݊mF               *
*                                                                              *
*    num10KeyON    - 10L[̓c[̏sc[\鏈      *
*    num10KeyIn    - 10L[lǂݍޏ                                    *
*    ReadJoystick  - WCXeBbNL[lǂݍޏ                  *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2019-05-03  ޒH[     Create                                 *
* ============================================================================ *
*   Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)                             *
*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "skST7735x_10key.h"

// 10L[f[^͗pϐ
uint8_t NumKeyFlag ;
uint8_t NumKeyInP ;
int8_t  X_NumArrayP , Y_NumArrayP ;
uint8_t X_NumDrawP , Y_NumDrawP ;
uint8_t NumKeyData[4][4][2] ;
uint8_t NumKeyMoji[16] = {'7','4','1','0','8','5','2','.','9','6','3','-','C','B',' ',0x7F} ;

/*******************************************************************************
*  skST7735x_10key(dspinfo)                                                    *
*    ̊֐Cu𐶐鎞̏(RXgN^)                *
*    dspinfo : `bvƃfBXvC̏                                      *
*******************************************************************************/
skST7735x_10key::skST7735x_10key(uint8_t dspinfo) : skST7735x(dspinfo) 
{
     DSP_Info = dspinfo ;
}
/*******************************************************************************
*  num10KeyON(xp,yp)                                                           *
*    10L[̓c[̏sc[\鏈                      *
*    xp : fBXvCW̗()Jnʒu                                     *
*    yp : fBXvCW̍s(c)Jnʒu                                     *
*******************************************************************************/
void skST7735x_10key::num10KeyON(uint8_t xp, uint8_t yp)
{
     uint8_t i , j , x1 , y1 ;

     NumKeyFlag = 1 ;
     NumKeyInP  = 0 ;
     // Key̏
     x1 = 0 ;
     for (i=0 ; i<4 ; i++) {
          for (j=0 ; j<4 ; j++) {
               NumKeyData[i][j][0] = NumKeyMoji[x1] ;
               NumKeyData[i][j][1] = 0 ;
               x1++ ;
          }
     }
     // \ʒu̕ۑ
     if (NUM_KEY_OUT_OFFSET < 0) X_NumDrawP = xp + abs(NUM_KEY_OUT_OFFSET) ;
     else X_NumDrawP  = xp ;
     Y_NumDrawP  = yp + 19 ;
     // J[\̏ʒu/
     X_NumArrayP = 1 ;
     Y_NumArrayP = 1 ;
     NumKeyData[X_NumArrayP][Y_NumArrayP][1] = 1 ; 
     // g̕`s
     NUM_KEY_FRAME_COLOR ;         // F
     // ̃C
     for (i=0 ; i<5 ; i++) {
          y1 = Y_NumDrawP + (i * 18) ;
          Line(X_NumDrawP,y1,X_NumDrawP+52,y1) ;
     }
     // c̃C
     for (j=0 ; j<5 ; j++) {
          x1 = X_NumDrawP + (j * 13) ;
          Line(x1,Y_NumDrawP,x1,Y_NumDrawP+72) ;
     }
     // ̕`s
     NUM_KEY_MOJI_COLOR ;          // ԐF
     for (i=0 ; i<4 ; i++) {
          x1 = X_NumDrawP + (i * 13) ;
          for (j=0 ; j<4 ; j++) {
               y1 = Y_NumDrawP + (j * 18) ;
               if (NumKeyData[i][j][1] == 1) {
                    NUM_KEY_FRAME_COLOR ;    // F
                    FillBox(x1,y1,x1+12,y1+17) ;
                    NUM_KEY_MOJI_COLOR ;     // ԐF
               }
               Putc2x(x1+2,y1+2,NumKeyData[i][j][0]) ;
          }
     }
}
/*******************************************************************************
*  ans = num10KeyIn(len, *sbuf)                                                *
*    10L[lǂݍޏ                                                    *
*    ̏́A"numKeyON()"sĂȂΏ܂B            *
*    len   : ͂f[^̒('.''-'̒l)                    *
*    *sbuf : ͂f[^i[obt@̃|C^Zbg            *
*    ans   : 1=͊  0=܂͒                                          *
*******************************************************************************/
uint8_t skST7735x_10key::num10KeyIn(uint8_t len,uint8_t *sbuf)
{
     uint8_t ans , i , x , y ;

     if (NumKeyFlag == 1) {
          NumKeyFlag = 2 ;
          // ͕\ʒuɐ`
          NUM_KEY_FRAME_COLOR ;         // F
          x = X_NumDrawP + NUM_KEY_OUT_OFFSET ;
          y = Y_NumDrawP - 19 ;
          Line(x,y,x+(len*11),y) ;
     }
     if (NumKeyFlag != 2) return 1 ;
     ans = 0 ;
     i = ReadJoystick() ;
     switch(i) {
        case BUTTON_DOWN:
        case BUTTON_UP:
        case BUTTON_RIGHT:
        case BUTTON_LEFT:
             // J[\̈ړ
             numKeyMove(i) ;
             break ;
        case BUTTON_SELECT:
             // KEY̑I
             ans = numKeySel(len,sbuf) ;
             if (ans == 1) NumKeyFlag++ ;
             break ;
        default:
             break ;
     }
     // WCXeBbN͏Ԃ̒
     delay(150) ;

     return ans ;
}
/*******************************************************************************
*  numDrawMove()                                                               *
*    zꏊ`悵Ȃ                                                *
*    zꏊƂ́AX_NumArrayP/Y_NumArrayP̈ʒu                         *
*******************************************************************************/
void skST7735x_10key::numDrawMove()
{
     uint8_t x1, y1 ;

     x1 = X_NumDrawP + (X_NumArrayP * 13) ;
     y1 = Y_NumDrawP + (Y_NumArrayP * 18) ;
     if (NumKeyData[X_NumArrayP][Y_NumArrayP][1] == 1) NUM_KEY_FRAME_COLOR ;    // F
     else                                              NUM_KEY_BACK_COLOR ;     // F
     FillBox(x1+1,y1+1,x1+12,y1+17) ;
     NUM_KEY_MOJI_COLOR ;                                                       // ԐF
     Putc2x(x1+2,y1+2,NumKeyData[X_NumArrayP][Y_NumArrayP][0]) ;
}
/*******************************************************************************
*  numKeyMove(value)                                                           *
*    WCXeBbNl̕                                              *
*    value : WCXeBbNlZbg                                    *
*******************************************************************************/
void skST7735x_10key::numKeyMove(uint8_t value)
{
     // ݂̃J[\
     NumKeyData[X_NumArrayP][Y_NumArrayP][1] = 0 ;
     numDrawMove() ;
     // ̏ꏊփJ[\ړ
     switch(value) {
        case BUTTON_DOWN:
             Y_NumArrayP++ ;
             if (Y_NumArrayP > 3) Y_NumArrayP = 0 ;
             break ;
        case BUTTON_UP:
             Y_NumArrayP-- ;
             if (Y_NumArrayP < 0) Y_NumArrayP = 3 ;
             break ;
        case BUTTON_RIGHT:
             X_NumArrayP++ ;
             if (X_NumArrayP > 3) X_NumArrayP = 0 ;
             break ;
        case BUTTON_LEFT:
             X_NumArrayP-- ;
             if (X_NumArrayP < 0) X_NumArrayP = 3 ;
             break ;
     }
     // ړ̃J[\\
     NumKeyData[X_NumArrayP][Y_NumArrayP][1] = 1 ; 
     numDrawMove() ;
}
/*******************************************************************************
*  ans = numKeySel(len,*sbuf)                                                  *
*    WCXeBbNl̃Z^[                                          *
*    "ENTER"ŕ̍ŌNULLăc[̕\                     *
*    len   : ͂镶̒                                                *
*    *sbuf : ͕i[obt@̃|C^                            *
*    ans   : 1="ENTER"L[  0=ĂȂ                             *
*******************************************************************************/
uint8_t skST7735x_10key::numKeySel(uint8_t len,uint8_t *sbuf)
{
     uint8_t c, *p, ans, x1, y1 ;

     ans = 0 ;
     p = (sbuf + NumKeyInP) ;
     c = NumKeyData[X_NumArrayP][Y_NumArrayP][0] ;
     y1 = Y_NumDrawP - 16 ;
     x1 = X_NumDrawP + NUM_KEY_OUT_OFFSET ;
     NUM_KEY_BACK_COLOR ;                                        // F
     switch(c) {
        case 'C': // ̓f[^̃NA
             NumKeyInP = 0 ;
             memset(sbuf,0,len) ;
             FillBox(x1,y1,x1+(len*11),Y_NumDrawP-2) ;
             break ;
        case 'B': // BackSpace
             if (NumKeyInP != 0) {
                  NumKeyInP-- ;
                  p-- ;
                  *p = 0 ;
                  x1 = x1 + (NumKeyInP*11) ;
                  FillBox(x1,y1,x1+11,Y_NumDrawP-2) ;
             }
             break ;
        case 0x7F: // ENTER
             *p = 0 ;
             // 10L[̓c[̕\
             FillBox(x1,y1-3,x1+(len*12),Y_NumDrawP-1) ;
             FillBox(X_NumDrawP,Y_NumDrawP,X_NumDrawP+53,Y_NumDrawP+73) ;
             ans = 1 ;
             break ;
        default: // ̕𓾂
             if (c != ' ') {
                  if (len <= NumKeyInP) break ;                  // len܂ł͂Ȃ
                  if (*p != 0) break ;                           // łɓ͍ς݂Ȃ珈Ȃ
                  if ((c == '-') && (NumKeyInP != 0)) break ;    // '-'͍ŏ̂ݓ
                  NUM_KEY_MOJI_COLOR ;                           // ԐF
                  Putc2x(x1+(NumKeyInP*11),y1,c) ;
                  *p = c ;
                  NumKeyInP++ ;
             }
             break ;
     }
     return ans ;
}
/*******************************************************************************
*  ans = ReadJoystick()                                                        *
*    WCXeBbNL[lǂݍޏ                                  *
*    ̊֐́Ah1.8C` 18bitJ[TFTV[h with microSD &             *
*    WCXeBbNḧׂɍĂ܂B                                  *
*    ̊֐́AW[]Ə㉺EςƎv̂Ŏgp  *
*    I[o[Chď܂傤B                                      *
*    ans : WCXeBbN̏()Ԃ                                  *
*******************************************************************************/
uint8_t skST7735x_10key::ReadJoystick() 
{
     float a ;

     a = analogRead(JOYSTICK_WIRING_PIN) ;
     a *= 5.0 ;
     a /= ANALOG_RESOLUTION ;      // AiO̕\

     if (a < 0.2) return BUTTON_LEFT ;
     if (a < 1.0) return BUTTON_DOWN ;
     if (a < 1.5) return BUTTON_SELECT ;
     if (a < 2.0) return BUTTON_RIGHT ;
     if (a < 3.2) return BUTTON_UP ;
     else         return BUTTON_NONE ;
}
