/*******************************************************************************
*  skST7735x_10key - ST7735`bvTFT-LCDp֐Cu                   *
*                                                 wb_t@C(10L[͕) *
*                    ST7735R/S`bv(ΐF^u)̂݊mF               *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY                    CHANGE/COMMENT                  *
* ---------------------------------------------------------------------------- *
*   1.00     2019-05-03  ޒH[     Create                                 *
* ============================================================================ *
*   Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)                             *
*******************************************************************************/
#ifndef _SKST7735X_10KEY_H_
#define _SKST7735X_10KEY_H_

#include "arduino.h"
#include "skST7735x.h"

/*******************************************************************************
*	萔̒`                                                                *
*******************************************************************************/

// 10L[f[^͗p萔
#define NUM_KEY_BACK_COLOR  ColorSet(0,0,0)       // wi̐F͍(18bit color)
#define NUM_KEY_FRAME_COLOR ColorSet(63,63,63)    // g̐F͔(18bit color)
#define NUM_KEY_MOJI_COLOR  ColorSet(63,0,0)      // ̐F͐(18bit color)

#define NUM_KEY_OUT_OFFSET  0                     // o͕̕\ꏊItZbg

// WCXeBbN
#define JOYSTICK_WIRING_PIN   3         // WCXeBbNڑĂAiOsw肷
#define ANALOG_RESOLUTION     1024.0    // ArduinõAiO\w肷

#define BUTTON_NONE           0
#define BUTTON_DOWN           1
#define BUTTON_RIGHT          2
#define BUTTON_SELECT         3
#define BUTTON_UP             4
#define BUTTON_LEFT           5


// ֐̃vg^Cv錾
/*******************************************************************************
*	NX̒`                                                              *
*******************************************************************************/
class skST7735x_10key : public skST7735x
{
  private:
     uint8_t NumKeyFlag ;
     uint8_t NumKeyInP ;
     int8_t  X_NumArrayP ;
     int8_t  Y_NumArrayP ;
     uint8_t X_NumDrawP ;
     uint8_t Y_NumDrawP ;
     uint8_t NumKeyData[4][4][2] ;

     void    numKeyMove(uint8_t value) ;
     void    numDrawMove() ;
     uint8_t numKeySel(uint8_t len,uint8_t *sbuf) ;

  public:
             skST7735x_10key(uint8_t dspinfo) ;
     void    num10KeyON(uint8_t xp, uint8_t yp) ;
     uint8_t num10KeyIn(uint8_t len,uint8_t *sbuf) ;
     virtual uint8_t ReadJoystick() ;

} ;

#endif
