/*******************************************************************************
*  skST7735x_img - ST7735`bvTFT-LCDp֐Cu(C[Wf[^o͕) *
*                  ST7735R/S`bv(ΐF^u)̂݊mF                 *
*                  (̃CúASDJ[hgp܂B)                  *
*                                                                              *
*    imgInit        - C[Wo͊֘A(SPI)̏s                  *
*    PutImage       - alo摜\鏈                               *
*    PutcK          - w肳ꂽʒuɊP(12x12)`悳鏈          *
*    PutsK          - w肳ꂽʒuɊ(12x12)`悳鏈        *
*                                                                              *
*    \ɂ́A"SHINOME.PDB"t@CKvłB                           *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2019-04-22  ޒH[     Create                                 *
* ============================================================================ *
*   Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)                             *
*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <SD.h>
#include "skST7735x_img.h"


/*******************************************************************************
*  skST7735x_img(dspinfo)                                                      *
*    ̊֐Cu𐶐鎞̏(RXgN^)                *
*    dspinfo : `bvƃfBXvC̏                                      *
*******************************************************************************/
skST7735x_img::skST7735x_img(uint8_t dspinfo) : skST7735x(dspinfo) 
{
     DSP_Info = dspinfo ;
}
/*******************************************************************************
*  ans= imgInit(cs)                                                            *
*    C[Wo͊֘A(SPI)̏s                                   *
*    cs  : rcJ[hIbrsw肷                              *
*    ans : 0=  1=s(SDĂȂ)                                *
*******************************************************************************/
uint16_t skST7735x_img::imgInit(uint8_t cs)
{
     // rcJ[h̏
     if (!SD.begin(cs)) {
         // J[h̏ɎsA܂͂rcĂȂ
         return 1 ;
     }

     return 0 ;
}
/*******************************************************************************
*  ans = PutImage(xp,yp,*filename)                                             *
*    alo摜\鏈                                                *
*    Windows24rbgJ[̂ݑΉ                                           *
*    xp        : fBXvCW̗()Jnʒu                              *
*    yp        : fBXvCW̍s(c)Jnʒu                              *
*    *filename : alõt@C(p啶)                                *
*    ans       : 0=I                                                    *
*                1=t@CI[vG[(t@C݂Ȃ)            *
*                2=BMPt@CłȂ́A24rbgJ[łȂ                 *
*******************************************************************************/
uint16_t skST7735x_img::PutImage(uint16_t xp, uint16_t yp, uint8_t *filename)
{
     struct BMP_HEADER hed ;
     uint8_t  *h ;
     File     fds ;
     uint8_t  rgb[3], sp, ans, l, i, x, y ;

     // t@C̓Ǎ݃I[v
     fds = SD.open(filename,FILE_READ) ;
     if (fds) {
          // t@C̃wb_ǂݏo
          h = (uint8_t *)&hed ;
          l = sizeof(BMP_HEADER) ;
          for (i=0 ; i<l ; i++) {
               *h = fds.read() ;
               h++ ;
          }
          // 摜f[^ǂݏo
          if ((hed.ImageType1 == 'B')&&(hed.ImageType2 == 'M')&&(hed.PixelColorNum == 24)) {
               // \Jnʒu()̐ݒ
               // BMPt@C͉摜f[^㉺΂ɋL^Ă
               x = xp ;
               l = (hed.ImageWidth-1) + xp ;
               y = yp + (hed.ImageHeight-1)  ;
               // ̃f[^͂S̔{PʂœZ߂ėL
               sp = 4 - ((hed.ImageWidth*3) % 4) ;
               if (sp == 4) sp = 0 ;
               // `͈͂1Cw肷
               RangSET(xp,l,y,y) ;
               SendByte(ST7735X_CMD_RAMWR,ST7735X_COMMAND) ;
               // 摜f[^̏ꏊ܂ŃV[N
               fds.seek(hed.HeaderSize) ;
               while (fds.available()) {
                    // RoCg(B,G,R)ǂݏo܂
                    rgb[2] = fds.read() ;         // B
                    rgb[1] = fds.read() ;         // G
                    rgb[0] = fds.read() ;         // R
                    // FĐFݒ肷
                    ReduceColorSet(rgb[0],rgb[1],rgb[2]) ;
                    // 1hbg`
                    SendByte(RGB[0],ST7735X_PARAMETER) ;
                    SendByte(RGB[1],ST7735X_PARAMETER) ;
                    SendByte(RGB[2],ST7735X_PARAMETER) ;
                    x++ ;
                    if (x > l) {
                         // S{ɑȂ͂OŖ߂ėL̂œǂݎ̂Ă
                         for (i=0 ; i<sp ; i++) fds.read() ;
                         // ̍sɈڂ
                         y-- ;
                         x = xp ;
                         // `͈͂1Cw肷
                         RangSET(xp,l,y,y) ;
                         SendByte(ST7735X_CMD_RAMWR,ST7735X_COMMAND) ;
                    }
               }
               ans = 0 ;
          } else ans = 2 ;    // BMPt@CłȂ́A24rbgJ[łȂ
          // t@C̃N[Y
          fds.close() ;
     } else {
          // t@C̃I[vG[
          // t@C݂ȂꍇG[łB
          ans = 1 ;
     }
     return ans ;
}
/*******************************************************************************
*  ans = PutcK(xp,yp,c)                                                        *
*    w肳ꂽʒuɊP(12x12)`悳鏈                           *
*    SDJ[htHgf[^ǂݏoĕ\܂B                      *
*    xp  : fBXvCW̗()Jnʒu                                    *
*    yp  : fBXvCW̍s(c)Jnʒu                                    *
*    c   : R[h(JISR[h)w肷A'F'Ȃ0x3727                     *
*    ans : 0=I                                                          *
*          1=t@CI[vG[(t@C݂Ȃ)                  *
*******************************************************************************/
uint16_t skST7735x_img::PutcK(uint16_t xp, uint16_t yp, uint16_t c)
{
     File     fds ;
     int8_t   b8 , b12 ;
     uint8_t  ans, f[18], i, pix, x, y ;
     uint32_t fp ;

     // tHgf[^̈ʒuvZ
     x = highByte(c) ;
     y = lowByte(c) ;

     fp = ((x - 0x21) * 0x5E) + (y - 0x21) ;
     fp = (fp * 18) + 0x78 ;
     // tHgt@C̓Ǎ݃I[v
     fds = SD.open("SHINOME.PDB",FILE_READ) ;
     if (fds) {
          // tHgf[^̏ꏊ܂ŃV[N
          fds.seek(fp) ;
          // 1ǂݍ
          for (i=0 ; i<18 ; i++) f[i] = fds.read() ;
          pix = 0 ;
          b8  = 7 ;
          b12 = 0 ;
          x  = xp ;
          y  = yp ;
          for (i=0 ; i<144 ; i++) { // 12x12hbg[v
               if (bitRead(f[pix], b8) == 1) PutPixel(x,y) ;     // 1hbg`
               b8-- ;
               if (b8 < 0) {
                    // 8rbgo͂ÃoCg
                    b8 = 7 ;
                    pix++ ;
               }
               x++ ;
               b12++ ;
               if (b12 >= 12) {
                    // PQrbgo͂A̍s
                    b12 = 0 ;
                    x = xp ;
                    y++ ;
               }
          }
          ans = 0 ;
          // t@C̃N[Y
          fds.close() ;
     } else {
          // t@C̃I[vG[
          // t@C݂ȂꍇG[łB
          ans = 1 ;
     }
     return ans ;
}
/*******************************************************************************
*  ans = PutsK(xp,yp,*s)                                                       *
*    w肳ꂽʒuɊ(12x12)`悳鏈                         *
*    xp  : fBXvCW̗()Jnʒu                                    *
*    yp  : fBXvCW̍s(c)Jnʒu                                    *
*    *s  : \镶w肵܂(̍ŌnullłȂ΂Ȃ܂)  *
*    ans : 0=I                                                          *
*          1=t@CI[vG[(t@C݂Ȃ)                  *
*******************************************************************************/
uint16_t skST7735x_img::PutsK(uint16_t xp, uint16_t yp, uint16_t *s)
{
     int ans ;

     while(*s) {
          ans = PutcK(xp,yp,*s++) ;
          if (ans != 0) break ;
          xp = xp + 13 ;
     }
     return ans ;
}

